/*
 ============================================================================
 Project     : 1.5+E Approximation Algorithm
 Author      : Lucas Angelo Silveira
               Universidade de Brasilia (UnB) - Brazil
               Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: May 03, 2015.
 ============================================================================
 */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "graph.h"
#include "algorithm.h"
#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/max_cardinality_matching.hpp>
int * genomeA;
int * genomeB;
int size_genome;
int sizeFAB;
int qtd_crom, qtd_ciclos1;
int vet[2];
int size_M;
int * Storage_signs;
using namespace boost;
typedef adjacency_list<vecS, vecS, undirectedS> my_graph;

void set_size(int t)
{
    size_genome=t;
}

void print()
{
    int i;
    for (i=0; i<size_genome; i++)
    {
        printf("%d, ", genomeA[i]);
    }
    
    printf("\n");
    
}

void Save()
{
    
    const char *name_archivo = "outapprox.txt"; //archivo "i"
    FILE *filePointer;
    int i=0;
    /*Guardar P;ermutacao no arquivo*/
    if ((filePointer = fopen(name_archivo,"w")) == NULL){
        printf("Output file could not be opened\n");
    }
    else{
        fprintf(filePointer,"%d\n",size_genome);
        for(i=0; i<size_genome; i++){
            
            fprintf(filePointer,"%d\n",genomeA[i]);
            
        }
        
        fprintf(filePointer,"%d\n",size_genome);
        for(i=0; i<size_genome; i++){
                fprintf(filePointer,"%d\n",genomeB[i]);
        }
        
    }
    fclose(filePointer);
    
}

//sorting graph M
void insertionSort(Graph_M * M, int tam) {
    
    int i, j, eleito[4];
    for (i = 1; i < tam; i++){
        eleito[0]=M[i].ciclo[0];
        eleito[1]=M[i].ciclo[1];
        eleito[2]=M[i].ciclo[2];
        eleito[3]=M[i].ciclo[3];
        j = i - 1;
        while ((j>=0) && (eleito[0] < M[j].ciclo[0])) {
            M[j+1].ciclo[0] = M[j].ciclo[0];
            M[j+1].ciclo[1] = M[j].ciclo[1];
            M[j+1].ciclo[2] = M[j].ciclo[2];
            M[j+1].ciclo[3] = M[j].ciclo[3];
            j--;
        }
        M[j+1].ciclo[0] = eleito[0];
        M[j+1].ciclo[1] = eleito[1];
        M[j+1].ciclo[2] = eleito[2];
        M[j+1].ciclo[3] = eleito[3];
    }
    
    

    
}


//search o prox element upper ao parameter
//return o index do upper element
int search_upper(int element)
{
    //  printf("infeliz upper %d \n", element);
    int i;
    for (i=0; i<size_genome; i++) {
        if (abs(genomeA[i])==element) {
            
            return i;
        }
    }
    
    return -1;
}

//search o prox element less ao parameter
//return o index do less element
int search_less(int element)
{
    int i;
    //printf("o que chegou nessa espelunca %d\n", element);
    for (i=0; i<size_genome; i++) {
        if (abs(genomeA[i])==element) {
            return i;
        }
    }
    
    return -1;
}

//1 for when they are neighbors in the same chromossome
int neighbors_genomeB(int element1, int element2)
{
    int cromo1=0;
    int cromo2=0;
    int i;
    int aux1=-1;
    int aux2=-1;
    for (i=0; i<size_genome; i++) {
        if (genomeB[i]==0)
        {
            if (aux1==-1) {
                cromo1++;
            }
            if (aux2==-1) {
                cromo2++;
            }
        }
        
        if (genomeB[i]==element1) {
            aux1=i;
        }
        
        if (genomeB[i]==element2) {
            aux2=i;
        }
        
        if (aux1!=-1 && aux2!=-1) {
            break;
        }
    }
    
    if (cromo1!=cromo2) {
        return 0;
    }
    else
        return 1;
}

//qtd chromossomes
void qtd_chromossomes(){
    int i;
    qtd_crom=0;
    for (i=0; i<size_genome; i++)
    {
        if (genomeA[i]==0) {
            qtd_crom++;
        }
    }
    qtd_crom++;
    
}

//check that the two genes are on the same chromosome A
int same_chromossome(int base, int procura)
{
    
    int i;
    int crombase=0;
    int cromoprocura=0;
    int posbase=-1;
    int posprocura=-1;
   
    for (i=0; i<size_genome; i++) {
        
            if (genomeA[i]==0) {
        
            if (posbase==-1) {
                
                crombase++;
            }
            
            if (posprocura==-1) {
                cromoprocura++;
            }
            
            
        }
        
        if (base==genomeA[i]) {
            posbase=i;
        }
        
        
        if (procura==genomeA[i]) {
            posprocura=i;
        }
        
        if (posbase!=-1 && posprocura!=-1) {
            break;
        }
    }
       
    if (crombase==cromoprocura) {
        return 1;
    }
    
    return 0;
    
}


//check that the two genes are on the same chromosome B
int same_chromossomeB(int base, int procura)
{
    
    int i;
    int crombase=0;
    int cromoprocura=0;
    int posbase=-1;
    int posprocura=-1;
    
    for (i=0; i<size_genome; i++) {
        
        if (genomeB[i]==0) {
            
            if (posbase==-1) {
                
                crombase++;
            }
            
            if (posprocura==-1) {
                cromoprocura++;
            }
            
            
        }
        
        if (base==genomeB[i]) {
            posbase=i;
        }
        
        
        if (procura==genomeB[i]) {
            posprocura=i;
        }
        
        if (posbase!=-1 && posprocura!=-1) {
            break;
        }
    }

    
    if (crombase==cromoprocura) {
        return 1;
    }
    
    return 0;
    
}
//indices of the end genes of the chromossomes in A
int * borders_chromossome()
{
    
    
    int i;
    int contador=1;
    int * retorno=(int *) calloc (2*qtd_crom, sizeof (int));
    retorno[0]=0;
    for (i=0; i<size_genome; i++) {
        if (genomeA[i]==0) {
            retorno[contador]=i-1;
            contador++;
            retorno[contador]=i+1;
            contador++;
        }
    }

    retorno[contador]=i-1;
    
    

    return retorno;
}

//show up blacks edges
void show_black_edges(Grafo_breakpoint * grafo){
    int i;
    for (i=0; i<size_genome; i++)
    {
        
        if(genomeA[i]==0)
            i++;
        if (grafo[i].esquerdo==-999999) {
            printf("-999999<---%d--->%d \n", genomeA[i],genomeA[grafo[i].direito]);
        }
        else if (grafo[i].direito==-999999) {
            printf("%d<---%d--->-999999 \n",genomeA[grafo[i].esquerdo], genomeA[i] );
        }
        else
            printf("%d<---%d--->%d \n",genomeA[grafo[i].esquerdo], genomeA[i],genomeA[grafo[i].direito]  );
        
    }//end for
    
    
}


//show up grays edges
void show_grays_edges(Grafo_breakpoint * grafo){
    int i, j;
    for (i=0; i<size_genome; i++)
    {
        
        if(genomeA[i]==0)
            i++;
        
        printf("[%d]-->",genomeA[i]);
        for (j=0; j<grafo[i].grays.indice_ligacoes; j++)
        {
            if (j==grafo[i].grays.indice_ligacoes-1) {
                printf("[%d]",genomeA[grafo[i].grays.ligacoes[j]]);
            }
            else
                printf("[%d]-->",genomeA[grafo[i].grays.ligacoes[j]]);
            
        }
        
        printf("\n");
        
        
    }//end for
    
    
}

// check if there gray edge between a and b
int is_gray(int a, int b, Grafo_breakpoint * grafo){
    int j;
    
    for (j=0; j<grafo[a].grays.indice_ligacoes; j++)
    {
     
        if (genomeA[grafo[a].grays.ligacoes[j]]== genomeA[b]) {
            return 1;
        }
        
    }
    return 0;
    
}



//build graph of breakpoints unsigned genomes A and B, this genomes are globals
Grafo_breakpoint *  build_grafo(){
    int i;
 Grafo_breakpoint * grafo= (Grafo_breakpoint *)malloc ((size_genome-qtd_crom) * sizeof (Grafo_breakpoint));
    
    for (i=0; i<(size_genome-qtd_crom); i++) {
        grafo[i].grays.indice_ligacoes=0;
    }
    
    
    //build black edges
    for (i=0; i<size_genome; i++)
    {
        if(genomeA[i]==0)
            i++;
        
        if (i==0)
        {
            grafo[i].esquerdo=-999999;//stores blacks edges
            grafo[i].direito=i+1;//stores blacks edges
            // printf("quanto q vale essa porcaria %d\n",graph[i].blacks.direito);
        }
        else if(i < size_genome-1 && genomeA[i+1]==0)
        {
            grafo[i].esquerdo=i-1;//stores blacks edges
            grafo[i].direito=-999999;//stores blacks edges
            
        }
        else if(genomeA[i-1]==0)
        {
            grafo[i].esquerdo=-999999;//stores blacks edges
            grafo[i].direito=i+1;//stores blacks edges
            
        }
        
        else
        {
            
            if (i== size_genome-1)
            {
                grafo[i].esquerdo=i-1;//stores blacks edges
                grafo[i].direito=-999999;//stores blacks edges
            }
            
            else
            {
                //printf("meu i");
                grafo[i].esquerdo=i-1;//stores blacks edges
                grafo[i].direito=i+1;//stores blacks edges
            }
            
            
        }//end else
        
        
    }//end for
    
    
    //****** building grays edges********
    int index;
    for (i=0; i<size_genome; i++)
    {
        if (genomeA[i]==0) {
            i++;
        }
        if (i==0)
        {
            //building only one gray edges
            index=search_upper(abs(genomeA[i])+1);
            
            if (index>-1) {
                grafo[i].grays.ligacoes[grafo[i].grays.indice_ligacoes]=index;//o maximo que podemos ter
                grafo[i].grays.indice_ligacoes+=1;
            }
            else
            {
            
                printf("\n ERROR IN THE BUILDING GRAPH SEARCH UPPER\n");
                
            }
        }//end if
        
        else if (i< size_genome-1 && genomeA[i+1]==0)
        {
            
            
            index=search_less(abs(genomeA[i])-1);
            
            if (index>-1) {
                grafo[i].grays.ligacoes[grafo[i].grays.indice_ligacoes]=index;//o maximo que podemos ter
                grafo[i].grays.indice_ligacoes+=1;
                
            }
            else
            {
                printf("\n ERROR IN THE BUILDING GRAPH SEARCH LESS\n");
            }
        }//end case when i+1=0
        
        else if (i>0 && genomeA[i-1]==0)
        {
            index=search_upper(abs(genomeA[i])+1);
            
            if (index==-1) {
                index=search_less(abs(genomeA[i])-1);
            }
        
            if (index>-1) {
                grafo[i].grays.ligacoes[grafo[i].grays.indice_ligacoes]=index;//o maximo que podemos ter
                grafo[i].grays.indice_ligacoes+=1;
                
            }
            else
            {
                printf("\n FATAL ERROR IN THE BUILDING GRAPH SEARCH UPPER\n");
                
            }
        }//end case when i-1=0
        
        else if (i==size_genome-1)
        {
            
            index=search_less(abs(genomeA[i])-1);
            int index2=index;
            if (!same_chromossomeB(genomeA[i] , genomeA[index])) {
                 index=search_upper(abs(genomeA[i])+1);
            
            }
            
            if (index>-1) {
                grafo[i].grays.ligacoes[grafo[i].grays.indice_ligacoes]=index;//o maximo que podemos ter
                grafo[i].grays.indice_ligacoes+=1;
                
            }
            else
            {
                //verificar se estao no mesmo cromossomo em B
                if (same_chromossomeB(genomeA[i] , genomeA[index2])) {
                    grafo[i].grays.ligacoes[grafo[i].grays.indice_ligacoes]=index2;//o maximo que podemos ter
                    grafo[i].grays.indice_ligacoes+=1;
                }
                
                else
                {
                    printf("\nFATAL ERROR IN THE BUILDING GRAPH SEARCH LESS\n");
                }
                
            }
            
            
        }//ende else if
        
        else
        {
           
            index=search_less(abs(genomeA[i])-1);
            
            if (index > -1) {
               
                grafo[i].grays.ligacoes[grafo[i].grays.indice_ligacoes]=index;
                grafo[i].grays.indice_ligacoes+=1;
                
            }
            else
            {
                
                printf("\n ERROR IN THE BUILDING GRAPH SEARCH LESS\n");
                
            }
            
            index=search_upper(abs(genomeA[i])+1);
            if (index > -1) {
                grafo[i].grays.ligacoes[grafo[i].grays.indice_ligacoes]=index;
                grafo[i].grays.indice_ligacoes+=1;
                
            }
            else
            {
                printf("\n ERROR IN THE BUILDING GRAPH SEARCH UPPER\n");
            }
            
        }//end else
        
        
    }//end for
    
  
     return grafo;
}//end build-graph


//built unsigned genomes A and B.
void criate_Genomes(int entrada[], int entrada2[]){
    int i;
    genomeA=(int *) calloc (size_genome, sizeof (int));
    genomeB=(int *) calloc (size_genome, sizeof (int));
    for (i=0; i<size_genome; i++)
    {
        genomeA[i]=entrada[i];
        
    }
    
    for (i=0; i<size_genome; i++)
    {
        genomeB[i]=entrada2[i];
        
    }
    
    
}

//check if is a tail of same crhomossome in the genome A
int tail_chromossome(int ind)
{
    if (ind==0) {
        return 1;
    }
    
    if(genomeA[ind-1]==0)
        return 1;
    
    return 0;
}

//check if is a head of same crhomossome in the genome A
int head_chromossome(int ind){
    
    if (ind == size_genome-1) {
        return 1;
    }
    
    if (genomeA[ind+1]==0) {
        return 1;
    }
    
    return 0;
}

//check if is a head of same crhomossome in the genome B
int head_chromossomeB(int ind){
    
    int j;
    
    for (j=0; j<size_genome; j++) {
        if (genomeB[j]==ind) {
            break;
        }
    }
    
    
    if (j == size_genome-1) {
        return 1;
    }
    
    if (genomeB[j+1]==0) {
        return 1;
    }
    
    return 0;
}


// Compute all the 1-cycles in the genome A
void Step1(){
    int i;
    
    
    for (i=0; i<size_genome; i++)
    {
        
        
        if (i < size_genome-1 && abs(abs(genomeA[i])- abs(genomeA[i+1]))==1 && !tail_chromossome(i) && !head_chromossome(i+1))
        {
            if(abs(genomeA[i])> abs(genomeA[i+1]))
            {
                
                if (Storage_signs[i]==-1) {
                    Storage_signs[i]=0;
                    genomeA[i]=genomeA[i]*-1;
                }
                
                if (Storage_signs[i+1]==-1) {
                    Storage_signs[i+1]=0;
                     genomeA[i+1]=genomeA[i+1]*-1;
                }
                
               
            }
            
            else
            {
                Storage_signs[i]=1;
                Storage_signs[i+1]=1;
            
            }
            qtd_ciclos1++;
        }
    }
    
    
 }



int diferente_crom(int p1, int p2){
    
    int * x= borders_chromossome();
    
    
  int i;
 
    
    for (i=0; i < 2* qtd_crom; i=i+2)
    {
        
        
        if (p1 <= x[i+1]) {
            break;
        }
    }
  
  
  
    if (p2<=x[i+1] ) {
        return 0;
    }
    
  
    
    
        return 1; 
}


/*distribute signal to the 2-cycles in the maximum matching M
 input : maximum matching M
*/
 void Sign_M(Graph_M  *M)
{
    int i;
     for (i=0; i< vet[0]; i++)
     {
         
                //first case x---t t----x+1
         if (abs(genomeA[M[i].ciclo[0]]) - abs(genomeA[M[i].ciclo[3]])==-1)
         {
             
             
             // x---y  y-1----x+1
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[2]])==1)
             {
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*1;
                 
                 if (Storage_signs[M[i].ciclo[1]]==0) {
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*-1;
                 }
                 else
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*1;
                 
                 if (Storage_signs[M[i].ciclo[2]]==0) {
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 }
                 else
                 M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*1;
                 
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*1;
             }
             
              //x----y-1 y----x+1
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[2]])==-1) {
                 
                 
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*1;
                 
                 if (Storage_signs[M[i].ciclo[1]]==1) {
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*1;
                 }
                 else
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*-1;
                 
                 if (Storage_signs[M[i].ciclo[2]]==1) {
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*1;
                 }
                 else
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*1;
             }
             
             
         }//end if
         
         
         // second case x----t t---x-1
         if (abs(genomeA[M[i].ciclo[0]]) - abs(genomeA[M[i].ciclo[3]])==1)
         {
             // x---y  y-1----x-1
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[2]])==1)
             {
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*-1;
                 
                 if (Storage_signs[M[i].ciclo[1]]==0) {
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*-1;
                 }
                 else
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*1;
                 
                 if (Storage_signs[M[i].ciclo[2]]==0) {
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 }
                 else
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*1;
                 
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*-1;
             }
             
            //x----y-1 y----x-1
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[2]])==-1) {
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*-1;
                 
                 if (Storage_signs[M[i].ciclo[1]]==1) {
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*1;
                 }
                 else
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*-1;
                 
                 if (Storage_signs[M[i].ciclo[2]]==1) {
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*1;
                 }
                 else
                 M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*-1;
             }
            
         }//end if
         
         
         
         //third case, two crossed cycles x--- t x+1---t
         if (abs(genomeA[M[i].ciclo[0]]) - abs(genomeA[M[i].ciclo[2]])==-1)
         {
             // x---y  x+1----y-1
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[3]])==1)
             {
                 if (Storage_signs[M[i].ciclo[0]]==0) {
                 M[i].sinais[0]=genomeA[M[i].ciclo[0]]*-1;
                 }
                 else
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*1;
                 
                 if (Storage_signs[ M[i].ciclo[1]]==0) {
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]]) *-1;
                 }
                 else
                 M[i].sinais[1]=genomeA[M[i].ciclo[1]];
                 
                 if (Storage_signs[ M[i].ciclo[2]]==1) {
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*1;
                 }
                 else
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 
                 if (Storage_signs[ M[i].ciclo[3]]==1) {
                      M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*1;
                 }
                 else
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*-1;
             }
             
             // x---y-1  x+1----y
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[3]])==-1)
             {
                
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*1;
                 M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*-1;
                 M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*1;
             }//end if
             
         }//end if third case
         
         //fourth case x--- t x-1---t
         if (abs(genomeA[M[i].ciclo[0]]) - abs(genomeA[M[i].ciclo[2]])==1)
         {
             // x---y  x-1----y-1
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[3]])==1)
             {
                 
                 if (Storage_signs[M[i].ciclo[0]]==1) {
                      M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]]);
                 }
                 else
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*-1;
                 
                 if (Storage_signs[M[i].ciclo[1]]==0) {
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*-1;
                 }
                 else
                 M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*1;
                 
                 if (Storage_signs[M[i].ciclo[2]]==0) {
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 }
                 else
                 M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*1;
                 
                 if (Storage_signs[M[i].ciclo[3]]==1) {
                     M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]]);
                 }
                 else
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*-1;
             }
             
             // x---y-1  x-1----y
             if (abs(genomeA[M[i].ciclo[1]]) - abs(genomeA[M[i].ciclo[3]])==-1)
             {
                 if (Storage_signs[M[i].ciclo[0]]==1) {
                      M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*1;
                 }
                 else
                 M[i].sinais[0]=abs(genomeA[M[i].ciclo[0]])*-1;
                 
                 if (Storage_signs[M[i].ciclo[1]]==1) {
                     M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*1;
                 }
                 else
                 M[i].sinais[1]=abs(genomeA[M[i].ciclo[1]])*-1;
                 
                 if (Storage_signs[M[i].ciclo[2]]==0) {
                     M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]])*-1;
                 }
                 else
                 M[i].sinais[2]=abs(genomeA[M[i].ciclo[2]]);
                 
                 if (Storage_signs[M[i].ciclo[3]]==0) {
                     M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]])*-1;
                 }
                 else
                 M[i].sinais[3]=abs(genomeA[M[i].ciclo[3]]);
             }
             
         }//end if fourth case
         
         
     }//end for
    
    
}





/*
Check if a 2-cycles is destroyed
 input: the gene to be tested, breakpoint graph, maximum matching M
*/
int Check_exclusion( int valor, Grafo_breakpoint * grafo,Graph_M  *M){
    int i;
    int conta=0;
    
      
    
    for (i=0; i< vet[0]; i++)
    {
        
    
            
            if (abs(M[i].sinais[0]) == abs(valor))
            {
                if (M[i].sinais[0] > valor || M[i].sinais[0] < valor ) {
                    conta++;
                }
                
            }
            
            if (abs(M[i].sinais[1])== abs(valor))
            {
                if (M[i].sinais[1]> valor || M[i].sinais[1]< valor)
                {
                    conta++;
                }
                
            }
            
            if (abs(M[i].sinais[2])== abs(valor))
            {
                if (M[i].sinais[2]> valor || M[i].sinais[2]< valor) {
                    conta++;
                }
                
            }
            
            if (abs(M[i].sinais[3])== abs(valor)) {
                if (M[i].sinais[3]> valor || M[i].sinais[3]< valor ) {
                    conta++;
                }
            }
            
        
        
    }//end for
    
    //destroys 2 cycles
    if (conta==2) {
        return 0;
    }
    
    
    return 1;

}


/*
 Built RMSP
 input:  breakpoint graph, maximum matching M, components of 2-cycles(isolates and share)
 */
void RSMSP(Grafo_breakpoint * grafo, Graph_M  *M , Componentes * comp){
    
    
    int i,j;
    int sentinela=1;
    int a=0;
    int b=0;
    int xi=0;
    int xj=0;
   
    for (i=0; i< vet[1]; i++)
    {
        
        // isolate 2-ciclo
        if (comp[i].tipo==0)
        {
            
            //verification if index of smps are in the same chromossomoe
            if (sentinela)
            {
              
                if(diferente_crom(M[comp[i].conteiner[0]].ciclo[1], M[comp[i].conteiner[0]].ciclo[3]))
                {
                    sentinela=0;
                   
                }
                
                if (sentinela)
                {
                    
                   int k;
                    for (k=M[comp[i].conteiner[0]].ciclo[0]+1; k<M[comp[i].conteiner[0]].ciclo[3]-1; k++) {
                        if (genomeA[k]==0) {
                            sentinela=0;
                            break;
                        }
                        
                        if (abs(genomeA[k]-genomeA[k+1])!=1) {
                            sentinela=0;
                            break;
                        }
                        
                        
                    }
                    
                }
             
                                
                if (sentinela) {
                    
                   
                    if (abs(abs(genomeA[ M[comp[i].conteiner[0]].ciclo[0]]) - abs(genomeA[ M[comp[i].conteiner[0]].ciclo[3]]))==1) {
                        sentinela=0;
                    }
                }
                
            }
            
            if (sentinela)
            {
                
                 
                comp[i].rsmp=1;
                
                //checking for gray edge (xi-1 xj)
                if (M[comp[i].conteiner[0]].ciclo[0]>0 && genomeA[M[comp[i].conteiner[0]].ciclo[0]-1]!=0 && (abs(abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]-1]) - abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]]))==1)) {
                    
                   
                    if (tail_chromossome(abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]-1])) && head_chromossomeB(abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]])) )
                    {
                        a=0;
                    }
                    else
                        a=1;
                    
                    
                }
                
                //checking for gray edge (xi xj+1)
                if ((M[comp[i].conteiner[0]].ciclo[3]+1 < size_genome)&&(abs(abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]]) - abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]+1]))==1) && genomeA[M[comp[i].conteiner[0]].ciclo[3]+1]!=0)
                {
                    b=1;
                }
                
                
                
                    
                    
                    if (a && b)
                        
                    {
                        
                                                
                        for (j=0; j<vet[1]; j++)
                        {
                            if (comp[j].tipo==0 && i!=j)
                            {
                                if (genomeA[M[comp[i].conteiner[0]].ciclo[0]] == genomeA[M[comp[j].conteiner[0]].ciclo[1]] &&
                                    genomeA[M[comp[i].conteiner[0]].ciclo[0]-1]== genomeA[M[comp[j].conteiner[0]].ciclo[0]] &&
                                    genomeA[M[comp[i].conteiner[0]].ciclo[3]]== genomeA[M[comp[j].conteiner[0]].ciclo[2]] &&
                                    genomeA[M[comp[i].conteiner[0]].ciclo[3]+1]== genomeA[M[comp[j].conteiner[0]].ciclo[3]]
                                    )
                                {
                                                                    
                                    comp[j].tipo=-1; 
                                    
                                
                                }//end if
                                
                                
                                
                            }//end if
                        }//end for delete com
                        
                        /***giving signals to the genes of the RSMSP****/
                        
                        
                        
                        if (abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]]) < abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]]) )
                        {
                            
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=1;//positive
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=1;//positive
                            
                        }
                        
                        else
                        {
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=0;//negative
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=0;//negative
                            
                        }
                        
                        /***********generating gray edge (r(xi-1), r(xj))****/
                        
                        if (abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]-1]) > abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]]))
                        {
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1]=0;//negative
                            
                        }
                        else//<
                        {
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1]=1;//positive
                            
                        }
                        
                        /***********generating gray edge (l(xi), l(xj+1))****/
                        if (abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]]) > abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]+1]))
                        {
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1]=0;//negative
                            
                        }
                        else//<
                        {
                            Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1]=1;//positive
                            
                        }
                        
               
                    }//end if a && b
                
                
                else if (a ||b)
                {
                                       
                    
                    //giving signs to the genes (r(xi-1) r(xj))
                    if (a)
                    {
                        int antigoa;
                         comp[i].rsmp=1;
                         
                        if (abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]-1]) > abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]]))
                        {
                            
                            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1]!=1 && Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]!=0
                                && Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]!=0)
                            {
                                

                                xi=abs(genomeA[ M[comp[i].conteiner[0]].ciclo[0]-1]) * -1;
                                antigoa= Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1];
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1]=0;//sign xi-1
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=1;//sign xi
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=1;//sign xj
                                
                            }
                            
                            
                        }//end if
                        else
                        {
                            
                            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1]!=0 && Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]!=1
                                && Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]!=1)
                            {
                                xi=abs(genomeA[ M[comp[i].conteiner[0]].ciclo[0]-1]) * 1;
                                antigoa= Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1];
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1]=1;//sign xi-1
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=0;//sign xi
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=0;//sign xj
                            }
                                
                            
                        }
                        
                        if (xi!=-1)
                        {
                            if (Check_exclusion(xi, grafo,M))
                            {// true caso nao p
                                
                                
                                comp[i].rsmp=1;
                                
                                //remove the 2-cycle
                                 int p;
                                //remove the 2-ciclo in a component 
                                for (j=0; j<vet[1]; j++)
                                {
                                    if (comp[j].tipo==1)
                                    {
                                       
                                        
                                        if (genomeA[M[comp[i].conteiner[0]].ciclo[0]-1] == genomeA[M[comp[j].conteiner[1]].ciclo[1]] && M[comp[i].conteiner[0]].ciclo[0]-2>=0&&
                                            genomeA[M[comp[i].conteiner[0]].ciclo[0]-2]== genomeA[M[comp[j].conteiner[1]].ciclo[0]]
                                            )
                                        {
                                                                                       
                                            
                                           
                                            if (M[comp[j].conteiner[1]].sinais[1]>0) {
                                                p=1;
                                            }
                                            else
                                            {
                                                p=0;
                                            }
                                            
                                            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1] ==p) {
                                            
                                                M[comp[j].conteiner[1]-1].desativar=1;
                                                
                                                
                                            }
                                            
                                            else
                                            {
                                            
                                                 M[comp[j].conteiner[1]].desativar=1;
                                                
                                            }
                                            
                                            
                                            
                                        }//end if
                                        
                                    }//end if of related component
                                    
                                    
                                    //check isolate 2-cycle
                                    if (comp[j].tipo==0)
                                    {
                                        
                                        if (genomeA[M[comp[i].conteiner[0]].ciclo[0]-1] == genomeA[M[comp[j].conteiner[0]].ciclo[1]] &&
                                            M[comp[i].conteiner[0]].ciclo[0]-2>=0&&
                                            genomeA[M[comp[i].conteiner[0]].ciclo[0]-2]== genomeA[M[comp[j].conteiner[0]].ciclo[0]]
                                            )
                                        {
                                            if (M[comp[j].conteiner[1]].sinais[1]>0)
                                            {
                                                p=1;
                                            }
                                            else
                                            {
                                                p=0;
                                            }
                                            
                                            
                                            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1] !=p)
                                            {
                                                comp[j].tipo=-1;
                                                M[comp[j].conteiner[0]].desativar=1;
                                               
                                                
                                            }
                                        
                                        }//end if
                                        
                                    }//end if 
                                    
                                }//end for 
                                
                                
                                
                            }
                            else
                            {
                                comp[i].rsmp=0;
                                
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]-1]=antigoa;
                               
                            }
                        }//end if
                        
                        xi=-1;
                    }//fim do a
                    
                    //giving signs to gray edge(l(xi), l(xj+1))
                    if (b)
                    {
                        int antigob;
                        
                        if (abs(genomeA[M[comp[i].conteiner[0]].ciclo[0]]) > abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]+1]))
                        {
                            
                            if ( Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]!=0 &&Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]!=0
                                &&  Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1]!=1) {
                                
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=1;
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=1;
                                antigob=Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1];
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1]=0;
                                xj=abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]+1])*-1;
                            }
                                
                                
                            
                        }//end if
                        else
                        {
                            if ( Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]!=1 &&Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]!=1
                                &&  Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1]!=0)
                            {
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=0;
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=0;
                                antigob=Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1];
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1]=1;
                                xj=abs(genomeA[M[comp[i].conteiner[0]].ciclo[3]+1])*1;
                            
                            
                            
                            }
                                
                        }//end else
                        
                        if (xj!=0)
                        {
                            
                            
                            if (Check_exclusion( xj, grafo,M)) {
                    
                                 comp[i].rsmp=1;
                                  
                                
                                //loop for delete case has that be done
                                int p;
                                for (j=0; j<vet[1]; j++)
                                {
                                   
                                    if (comp[j].tipo==1)
                                    {
                                        
                                        
                                        if (genomeA[M[comp[i].conteiner[0]].ciclo[3]+1] == genomeA[M[comp[j].conteiner[1]].ciclo[2]] &&
                                            M[comp[i].conteiner[0]].ciclo[3]+2<size_genome &&
                                            genomeA[M[comp[i].conteiner[0]].ciclo[3]+2]== genomeA[M[comp[j].conteiner[1]].ciclo[3]]
                                            )
                                        {
                                            
                                                                        
                                            if (M[comp[j].conteiner[1]].sinais[2]>0) {
                                                p=1;
                                                                                           }
                                            else
                                            {
                                                p=0;
                                            }
                                            
                                            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1] ==p)
                                            {
                                                
                                                
                                                M[comp[j].conteiner[1]-1].desativar=1;
                                               
                                                
                                            }
                                            else
                                            {//eliminar o ultimo 2-ciclo na componente
                                            
                                                 M[comp[j].conteiner[1]].desativar=1;
                                            }
                                            
                                            
                                            
                                        }//end if
                                        
                                    }//end if of related component
                                    
                                    
                                    //check isolates 2-cycles
                                    if (comp[j].tipo==0)
                                    {
                                        
                                        if (genomeA[M[comp[i].conteiner[0]].ciclo[3]+1] == genomeA[M[comp[j].conteiner[0]].ciclo[2]] &&
                                            M[comp[i].conteiner[0]].ciclo[3]+2<size_genome&&
                                            genomeA[M[comp[i].conteiner[0]].ciclo[3]+2]== genomeA[M[comp[j].conteiner[0]].ciclo[3]]
                                            )
                                        {
                                            if (M[comp[j].conteiner[0]].sinais[2]>0)
                                            {
                                                p=1;
                                            }
                                            else
                                            {
                                                p=0;
                                            }
                                            
                                            
                                            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1] !=p)
                                            {
                                                
                                                
                                                M[comp[j].conteiner[0]].desativar=0;
                                                comp[j].tipo=-1;
                                                
                                                
                                            }
                                            
                                        }//end if
                                        
                                    }//end if 
                                    
                                }//end for 
                                
                                
                                
                                
                                
                                
                            }
                            else
                            {
                                comp[i].rsmp=0;
                                
                                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]+1]=antigob;
                                
                            }
                            
                                
                       }
                        xj=0;
                        
                    }//end if
                    
                    
                    
                
                }// end if a ||b
                
                else
                {
                    
                    comp[i].rsmp=0;
                   
                }
                a=0;
                b=0;
            }
            else
            {
                comp[i].rsmp=0;
                sentinela=1;
            }//end else
        
        }//end isolate 2-cycle 
    }

    

    
    
}


/*
 Built FAB graph
 input: breakpoint graph
 */
Graph_M  * create_FAB(Grafo_breakpoint * grafo){
	sizeFAB=1;
	Grafo_FAB * FAB=(Grafo_FAB*)malloc ((size_genome) * sizeof (Grafo_FAB));
	int i, j;
    Grafo_breakpoint * grafoaux= build_grafo();
    
    for (i=0; i<size_genome; i++)
	{
        
        if (genomeA[i]!=0 && grafo[i].esquerdo!=-999999 && (abs(genomeA[i-1] - genomeA[i])!=1))
        {
       
            FAB[sizeFAB].esquerdo2=grafo[i].esquerdo;
			FAB[sizeFAB].direito2=i;
            sizeFAB++;
			
		}//en if 
	}//end for 
    
      int cont=0;
  
	int parei[sizeFAB];

   
	for(i=1; i< sizeFAB; i++)
        
	{
     
   
        cont=-1;
		for(j=1;j<sizeFAB; j++)
		{
			if(i!=j)
			{
                
				if(is_gray(FAB[i].esquerdo2, FAB[j].direito2, grafo) && is_gray(FAB[i].direito2, FAB[j].esquerdo2, grafo) )
				{    cont++;
                    
                    FAB[i].conteiner2[cont]=j;
					FAB[i].flag='n';
					
				}
                
				if(is_gray(FAB[i].esquerdo2, FAB[j].esquerdo2, grafo) && is_gray(FAB[i].direito2, FAB[j].direito2, grafo) )
				{
                    cont++;
                    FAB[i].conteiner2[cont]=j;
					FAB[i].flag='p';
					
				}
				
			}
		}//end for 
        
      parei[i]=cont;
     grafo=grafoaux;
        
	}//end for mais externo


    //Criar o matching graph M
    const int n_vertices = sizeFAB;
	my_graph g(n_vertices);
   
    
	for(i=1; i< sizeFAB; i++)
	{
		
       
		for( j=0; j <=parei[i]; j++)
		{
           add_edge(i, FAB[i].conteiner2[j], g);
		}
		
	}//end for
    
    
     //Encontrar "the maximun cardinality matching" M
	std::vector<graph_traits<my_graph>::vertex_descriptor> mate(n_vertices);
	checked_edmonds_maximum_cardinality_matching(g, &mate[0]);
    cont=0;
    graph_traits<my_graph>::vertex_iterator vi, vi_end;
	for(tie(vi,vi_end) = vertices(g); vi != vi_end; ++vi){
		if (mate[*vi] != graph_traits<my_graph>::null_vertex() && *vi < mate[*vi]){
			//std::cout << "{" << *vi << ", " << mate[*vi] << "}" << std::endl;//--------
            cont++;
		
		}
	}
    
    Graph_M  * M=(Graph_M*)malloc (cont * sizeof (Graph_M));
    cont=0;
    for(tie(vi,vi_end) = vertices(g); vi != vi_end; ++vi){
		if (mate[*vi] != graph_traits<my_graph>::null_vertex() && *vi < mate[*vi]){

            M[cont]. ciclo[0]=FAB[(int)*vi].esquerdo2;
            M[cont]. ciclo[1]=FAB[(int)*vi].direito2;
            M[cont]. ciclo[2]=FAB[(int)mate[*vi]].esquerdo2;
            M[cont]. ciclo[3]=FAB[(int)mate[*vi]].direito2;
            cont++;
		}
	}//end for
  
    free(FAB);
    insertionSort(M, cont);
    size_M=cont;
    vet[0]=cont; // size of M
    
return M;
}//end function





/*
building components
 input:  maximum matching M
 */
Componentes * build_comp(Graph_M  *M){

    Componentes * comp= (Componentes*)malloc (size_M * sizeof (Componentes));
        int g1a, g1b, g2a, g2b, g3a, g3b, g4a, g4b,i;
         int indice=0;
        comp[indice].conteiner[0]=0;
        int sentinela=0;
        int contador=0;
        g1a=abs(genomeA[ M[0].ciclo[0]]);
        g2a=abs(genomeA[ M[0].ciclo[1]]);
        if (abs(g1a - abs(genomeA[ M[0].ciclo[2]]))==1 )
        {
            
            g1b=genomeA[ M[0].ciclo[2]];
            g2b=genomeA[ M[0].ciclo[3]];
            
            if (abs(abs(g2a)- abs(g2b)) !=1)
            {
                
                g1b=genomeA[ M[0].ciclo[3]];
                g2b=genomeA[ M[0].ciclo[2]];
            }
            
            
        }
        else
        {
            
            g1b=genomeA[ M[0].ciclo[3]];
            g2b=genomeA[ M[0].ciclo[2]];
            
            if (abs(abs(g2a)- abs(g2b)) !=1)
            {
                g1b=genomeA[ M[0].ciclo[2]];
                g2b=genomeA[ M[0].ciclo[3]];
            }
        }
        
        for (i=1; i<size_M; i++)
        {            
            if (i==size_M) {
                sentinela=1;
                break;
            }
            
                        
            g3a=genomeA[ M[i].ciclo[0]];
            g4a=genomeA[ M[i].ciclo[1]];
            
            
            if (abs(abs(g3a) - abs(genomeA[ M[i].ciclo[2]]))==1 )
            {
                
                g3b=genomeA[ M[i].ciclo[2]];
                g4b=genomeA[ M[i].ciclo[3]];
                
                if (abs(abs(g4a)- abs(g4b)) !=1)
                {
                    g3b=genomeA[ M[i].ciclo[3]];
                    g4b=genomeA[ M[i].ciclo[2]];
                }
                
            }
            else
            {
                g3b=genomeA[ M[i].ciclo[3]];
                g4b=genomeA[ M[i].ciclo[2]];
                
                if (abs(abs(g4a)- abs(g4b)) !=1)
                {
                    g3b=genomeA[ M[i].ciclo[2]];
                    g4b=genomeA[ M[i].ciclo[3]];
                }
            }
          
            
            if (g1a==g3a && g1b==g3b)
            {
                sentinela=0;
                
                
            }
            else if(g1a==g4a && g1b==g4b)
            {
                sentinela=0;
                
            }
            
            else if(g2a==g3a && g2b==g3b)
            {
                sentinela=0;
            }
            
            else if(g2a==g4a && g2b==g4b)//g2a= g4a and g2b=g4b
            {
                sentinela=0;
                
            }
            
            else
            {
                
                sentinela=1;
            }
            g1a=g3a;
            g2a=g4a;
            g1b=g3b;
            g2b=g4b;
            contador++;
            
            //open one new component
            if (sentinela)
            {
                comp[indice].conteiner[1]=contador-1;
                if (comp[indice].conteiner[0]!= comp[indice].conteiner[1]) {
                    comp[indice].tipo=1;// 1 to share para compartilhado
                }
                else
                    comp[indice].tipo=0;// 0 to isolate
                
                indice++;
                
                //built one new component 
                comp[indice].conteiner[0]=contador;
                contador=i;
                
            }//end 
            
            
        }//end for build components
        
        
        if (size_M==1) {
            comp[indice].conteiner[0]=0;
            comp[indice].conteiner[1]=0;
            comp[indice].tipo=0;// 0
            indice=1;
        }
        //pega o ultimo 2-ciclo
        
        else if (sentinela) {
            comp[indice].conteiner[0]=i-1;
            comp[indice].conteiner[1]=i-1;
            comp[indice].tipo=0;// para isolado
            indice++;
            
        }
        
        else // e uma componente relacionada
        {
            comp[indice].conteiner[1]=contador;
            comp[indice].tipo=1;// 1 
            indice++;
            
            
        }
        
        
       
    vet[1]=indice;//size_genome of the arrangement of the components

    return comp;



}


/*
 Distribution for the sinals of the components
 input:  maximum matching M and components of 2-cycles(isolates and share)
 */
void Step4(Graph_M  *M,  Componentes * comp){
    
        int i,j;
    for (i=0; i< vet[1]; i++)
    {
         
        if (comp[i].tipo==0)
        {//comp isolated
         
           
           
                if (M[comp[i].conteiner[0]].sinais[0]>0 && Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]!=0 ) {
                    
                   
                    Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=1;
                }
                else
                {
                    
                    if (Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]!=1 && M[comp[i].conteiner[0]].ciclo[0] >0 && genomeA[M[comp[i].conteiner[0]].ciclo[0]-1]!=0) {
                         
                        Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=0;
                    }
                
                }
                
            
            
                if (M[comp[i].conteiner[0]].sinais[1]>0 && Storage_signs[M[comp[i].conteiner[0]].ciclo[1]]!=0) {
                    Storage_signs[M[comp[i].conteiner[0]].ciclo[1]]=1;
                }
                else
                {
                    if (Storage_signs[M[comp[i].conteiner[0]].ciclo[1]]!=1)
                    {
                         Storage_signs[M[comp[i].conteiner[0]].ciclo[1]]=0;
                    }
                   
                }
                
            
            
            
               if (M[comp[i].conteiner[0]].sinais[2]>0 && Storage_signs[M[comp[i].conteiner[0]].ciclo[2]]!=0) {
                    Storage_signs[M[comp[i].conteiner[0]].ciclo[2]]=1;
                }
                else
                {
                    if (Storage_signs[M[comp[i].conteiner[0]].ciclo[2]]!=1) {
                        Storage_signs[M[comp[i].conteiner[0]].ciclo[2]]=0;
                    }
                }
                
            
            
                if (M[comp[i].conteiner[0]].sinais[3]>0 && Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]!=0) {
                    Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=1;
                }
                else
                {
                    if (Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]!=1 && M[comp[i].conteiner[0]].ciclo[3]<size_genome-1) {
                        Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=0;
                    }
                
                }
                
                
            
        }//end position 0
        else
        {
            
            if (comp[i].tipo==1)
            {
              
                for (j=comp[i].conteiner[0]; j<=comp[i].conteiner[1]; j++)
                {
                    
                    if (!M[j].desativar)
                    {
                        
                    
                        if (M[j].sinais[0]>0 && Storage_signs[M[j].ciclo[0]]!=0) {
                            Storage_signs[M[j].ciclo[0]]=1;
                        }
                        else
                        {
                            if (Storage_signs[M[j].ciclo[0]]!=1 && M[j].ciclo[0]>0) {
                                Storage_signs[M[j].ciclo[0]]=0;
                            }

                        }
                        
                    
                    
                    
                        if (M[j].sinais[1]>0 && Storage_signs[M[j].ciclo[1]]!=0) {
                            Storage_signs[M[j].ciclo[1]]=1;
                        }
                        else
                        {
                        
                            if (Storage_signs[M[j].ciclo[1]]!=1) {
                                Storage_signs[M[j].ciclo[1]]=0;
                            }
                        
                        }
                        
                    
                        if (M[j].sinais[2]>0 && Storage_signs[M[j].ciclo[2]]!=0) {
                            Storage_signs[M[j].ciclo[2]]=1;
                        }
                        else
                        {
                            if (Storage_signs[M[j].ciclo[2]]!=1) {
                                Storage_signs[M[j].ciclo[2]]=0;
                            }
                            
                        }
                        
                                   
                    
                        if (M[j].sinais[3]>0 && Storage_signs[M[j].ciclo[3]]!=0) {
                            Storage_signs[M[j].ciclo[3]]=1;
                        }
                        else
                        {
                            if (Storage_signs[M[j].ciclo[3]]!=1 && M[j].ciclo[3]<size_genome-1) {
                                Storage_signs[M[j].ciclo[3]]=0;
                            }
                        
                        }
                        
                    }//end if
                    
                    if (!M[j].desativar) {
                        j++;
                    }
                    
                    
                }//end for
                
                
                
            }//end if
        
        
        }//end else
        
    }


}

//checks to see if the index is not a limit of chromosome 
int not_fronteira(int ind)
{
    if (genomeA[ind]==0) {
        return 0;
    }
    
    else return 1;

}

int tail_chromossomeB(int ind)
{
    int j;
    
    for (j=0; j<size_genome; j++) {
        if (genomeB[j]==ind) {
            break;
        }
    }
    
    
    if (j==0) {
        return 1;
    }
    
    if(genomeB[j-1]==0)
    {
        return 1;
    }
    return 0;
}



int positiongenomeB(int b){
    int i;
    
    for (i=0; i<size_genome; i++) {
        if (abs(genomeB[i])==abs(b)) {
            return i;
        }
    }
    return 0;

}


//distribution of sinals to the genes that not have sinals
void Step5(){

    int i, v;
    int vigia=1;
    for (i=0; i<size_genome; i++)
    {
        
        if (Storage_signs[i]==-1 && not_fronteira(i))
        {
            
    
            if (tail_chromossome(i)) {
               
                v=positiongenomeB(genomeA[i]);
                
                if (v==0) {
                     Storage_signs[i]=1;
                }
                
                else if(v<size_genome-1 && genomeB[v-1]==0 )
                {
                     Storage_signs[i]=1;
                
                }
                
                else
                     Storage_signs[i]=0;
                                
                
                
            }
            
            //verify that this is not the end of a chromosome as head
            
            else if (head_chromossome(i))
            {
             
                v=positiongenomeB(genomeA[i]);
                if (v==size_genome-1) {
                    Storage_signs[i]=1;
                }
                else if( v<size_genome-1 && genomeB[v+1]==0)
                {
                    Storage_signs[i]=1;
                    
                }
                else
                    Storage_signs[i]=0;
                
            }
            
            // is a gene internal in the genome
            else
            {
                
                if (vigia) {
                   Storage_signs[i]= 1;
                    vigia=0;
                }
                else
                {
                    Storage_signs[i]= 0;
                    vigia=1;
                    
                }
            
            
            }
            
            
            
        }//end if main
       
    }




}


//remove the RSMSPs case exists
void Step6(Graph_M  *M,  Componentes * comp){

    int i;
    for (i=0; i< vet[0]; i++)
    {
        if (comp[i].tipo==0 && comp[i].rsmp==1) {
            
            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]==1)
                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=0;
                
            else
                Storage_signs[M[comp[i].conteiner[0]].ciclo[0]]=1;
          
            if (Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]==1)
                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=0;
            
            else
                Storage_signs[M[comp[i].conteiner[0]].ciclo[3]]=1;
            
        }
    }//end for

    
  
}//end function

//distribution of sinals the gnes in the genome A
void Sign_genomeA(){
    
    int i;
    
    for (i=0; i<size_genome; i++)
    {
        
        if (i<size_genome-1 && abs(abs(genomeA[i]) - abs(genomeA[i+1]))==1 ) {
            if (abs(genomeA[i])>abs(genomeA[i+1]))
            {
                Storage_signs[i]=0;
            }
            else
                Storage_signs[i]=1;
        }
        
        if(Storage_signs[i]==0)
            genomeA[i]=abs(genomeA[i])*-1;
        
        if (Storage_signs[i]==1) {
            genomeA[i]=abs(genomeA[i])*1;
        }
        
        
        if (tail_chromossome(i)) {
            
            if (tail_chromossomeB(abs(genomeA[i]))) {
                if (genomeA[i]<0) {
                    genomeA[i]=genomeA[i]*-1;
                }
            }
           
        }

        if (head_chromossome(i)) {
            
            if (head_chromossomeB(abs(genomeA[i]))) {
                if (genomeA[i]<0) {
                    genomeA[i]=genomeA[i]*-1;
                }
            }
            
            
        }
        
    }//end for
    
   

}


/*
 Function where meets all other steps */
void Kernel()
{
    qtd_chromossomes();
    Storage_signs=(int *) calloc (size_genome, sizeof (int));
    int i;
    //initially all are has sinals -1 e posteriorly some has sinals 0 for negative and 1 for positive
    for (i=0; i<size_genome; i++) {
        Storage_signs[i]=-1;
    }
    
    Step1();
    Grafo_breakpoint * grafo = build_grafo();

    //Step 2
    Graph_M  *M= create_FAB(grafo); 
    Componentes * comp;
   
    
    if (size_M>0) {
    
         comp=build_comp(M);
    }
   
    //avoid case when we do not have components
    if (vet[0]!=0)
    {
       
        for (i=0; i< vet[0]; i++)
        {
            M[i].desativar=0;
        }
        Sign_M(M);
        RSMSP(grafo,M, comp);
        Step4(M, comp);
    
    }//ind if

    Step5();
   
    
    if (vet[0]>0)
    {
        //remove the RSMSPs
        Step6(M, comp);
        
   }
    
    Sign_genomeA();
    Save();//save the solution of the algorithm

}

