/*
 ============================================================================
 Project     : Standard GA Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: May 03, 2015.
 ============================================================================
 */

#ifndef _Alg_Simple_Genetic_h
#define _Alg_Simple_Genetic_h
#include "structures.h"


void read_permutation_of_file(char* name, permutation *perm);

void see_permutation(permutation *perm);


void see_Population(permutation *perm,Population *pob);


// Procedure that generates the initial Population

void Population_init(Population *pob, permutation *perm);


//calculate the tranlocation distance to each genome of the Population
void fitness_Population(Population *pob, int flag);

//flag(0) is initial Population or flag(1) if contains descendent Population
void see_fitness(Population *pob ,int flag);



//orders Population by fitness
void countingSort(Population *pob, int k);



//takes best solution
void selection(Population *pob,  int n_generetion, int * better_soluction);


void crossover(Population *pob, permutation *perm);

void mutation(Population *pob, permutation *perm);



void substitution(Population *pob);



void Genetic(float probcrossover, float probmutacao, float probselecao, float probsubstitution);
#endif
