
/*
 ============================================================================
 Project     : Distance Translocation Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: May 09, 2015.
 ============================================================================
 */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "validate_input.c"

int TAMANHO_CAPPEPLUS;// variable global for represent an extended genome


void set_TAMANHO_CAPPEPLUS(int entrada[], int size)
{
   
 int *estatusA=status_A(entrada, size);// function defined in validate_input.c
 int k;
 TAMANHO_CAPPEPLUS=0;
 //qtd_cromossomo is global of validate_input.h
 for(k=0; k<qtd_cromossomo; k++)
        TAMANHO_CAPPEPLUS=TAMANHO_CAPPEPLUS + estatusA[k]+2;
  

 free(estatusA);
}


//mapping a Plus genome extended
int * cappingP(int entrada[], int size)
{   

    int *a;
    int *estatusA=status_A(entrada, size);
    int i=0;
    int k=0;
	
    
    a= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    
    int cont2=0;
	
    for (; i<qtd_cromossomo;i++) {
     
        for(k=0; k<estatusA[i]; k++) {
            if(k==0)
            {
                a[cont2]=0;
                cont2++;
            }
            
            a[cont2]=GENOMA_A[i][k];
            
            cont2++;
            if(k+1 == estatusA[i])
            {
                a[cont2]=qtd_genes+1;
                 cont2++;
            }
            
        }
    }
    
   free(estatusA);
return a;
}




//mapping a Minus genome extended
int * cappingM(int entrada[], int size)
{   
   
   
    int i=0;
    int k=0;
    int *estatusA=status_A(entrada, size); 
    int* b=(int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    
    int cont2=0;
	for (; i<qtd_cromossomo;i++)
    {
        for(k=0; k<estatusA[i]; k++)
        {
            if(k==0)
            {
                b[cont2]=-1* (qtd_genes+1);
                cont2++;
            }
            
            b[cont2]=GENOMA_A[i][k];
            cont2++;
            if(k+1 == estatusA[i])
            {
                b[cont2]=0;
                cont2++;
            }
            
        }
          
    }
    free(estatusA);
return b;
}
